# Copyright (C) 2016-2018 Virgil Security Inc.
#
# Lead Maintainer: Virgil Security Inc. <support@virgilsecurity.com>
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     (1) Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
#     (2) Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in
#     the documentation and/or other materials provided with the
#     distribution.
#
#     (3) Neither the name of the copyright holder nor the names of its
#     contributors may be used to endorse or promote products derived from
#     this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
import unittest

from test.cryptography import crypto_test
from test.cryptography import compatibility_test
from test.client import virgil_client_test
from test.client import request_signer_test
from test.storage import default_storage_test
from test.api import test_virgil_buffer
from test.api import test_virgil_key
from test.api import test_virgil_card
from test.api import test_key_manager
from test.api import test_card_manager


def load_tests(loader, standard_tests, pattern):
    suite = unittest.TestSuite()
    suite.addTests(loader.loadTestsFromModule(crypto_test))
    suite.addTests(loader.loadTestsFromModule(compatibility_test))
    suite.addTests(loader.loadTestsFromModule(virgil_client_test))
    suite.addTests(loader.loadTestsFromModule(request_signer_test))
    suite.addTests(loader.loadTestsFromModule(default_storage_test))
    suite.addTests(loader.loadTestsFromModule(test_virgil_buffer))
    suite.addTests(loader.loadTestsFromModule(test_virgil_key))
    suite.addTests(loader.loadTestsFromModule(test_virgil_card))
    suite.addTests(loader.loadTestsFromModule(test_key_manager))
    suite.addTests(loader.loadTestsFromModule(test_card_manager))
    return suite


if __name__ == '__main__':
    unittest.main()
